//
//  TupleComparator.java
//  MinionTableConstraint
//
//  Created by ian miguel on 15/04/2006.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//
package queso.constraints;

import java.util.* ;

public class TupleComparator implements Comparator {
  int significantIndex ;
  int arity ;
  
  /* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
     Constructor
	 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% */
  TupleComparator (int i, int a) {
    significantIndex = i ;
	arity = a ;
  }

  /* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
     compare
	 Order is lexicographic. Significant index given in constructor.
	 Order of significance thereafter is with index order.
	 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% */
  public int compare(Object obj1, Object obj2) {
	int[] tuple1 = (int[]) obj1 ;
	int[] tuple2 = (int[]) obj2 ;
	if (tuple1[significantIndex] != tuple2[significantIndex])
	  return tuple1[significantIndex] - tuple2[significantIndex] ;
	for (int tupleIndex = 0; tupleIndex < arity; tupleIndex++)
	  if ((tupleIndex != significantIndex) &&
	  	  (tuple1[tupleIndex] != tuple2[tupleIndex]))
	    return tuple1[tupleIndex] - tuple2[tupleIndex] ;
	return 0 ;
  } 
}

