package queso.constraints;

import queso.core.*;

public class nightingaletuples_nofail extends nightingaletuples
{
    public nightingaletuples_nofail(mid_domain [] vars, qcsp prob, predicate_wrapper pred, boolean listperliteral, boolean hologram)
    {
        super(vars, prob, pred, listperliteral, hologram);
    }
    public nightingaletuples_nofail(mid_domain [] vars, qcsp prob, int [][] tuples, boolean listperliteral, boolean hologram)
    {
        super(vars, prob, tuples, listperliteral, hologram);
    }
    public nightingaletuples_nofail(mid_domain [] vars, qcsp prob, int [][] tuples)
    {
        super(vars, prob, tuples);
    }
    public nightingaletuples_nofail(mid_domain [] vars, qcsp prob, predicate_wrapper pred)
    {
        super(vars, prob, pred);
    }
    
    public boolean establish()
    {
        boolean flag=super.establish();
        if(!flag)
        {
            // prune all values
            for(mid_domain md : variables)
            {
                for(int i=md.lowerbound(); i<=md.upperbound(); i++)
                    if(md.is_present(i)) 
                        md.exclude(i, this);
            }
        }
        return true;
    }
    
    public boolean propagate(int var, int val)
    {
        boolean flag=super.propagate(var,  val);
        if(!flag)
        {
            // prune all values
            for(mid_domain md : variables)
            {
                for(int i=md.lowerbound(); i<=md.upperbound(); i++)
                    if(md.is_present(i)) 
                        md.exclude(i, this);
            }
        }
        return true;
    }
}
